<?php

	class controller_plugin_feedback_with_attachments extends plugin 
	{

		public function action_settings($plugin) 
		{
			//core::print_r($plugin);
			$params = unserialize($plugin['params']);

			if (isset($_POST['edit_settings'])) {
				$this->page['params'] = serialize(array(
					'mail_to'           => $_POST['mail_to'],
				));
				return $this->page;
			} 

			$this->data['mailText'] = $params['mail_to'];
 
			$explodedMailTo = explode(', ', $params['mail_to']);
			$mailCheck = '';
			foreach ($explodedMailTo as $key => $value) {
				if (!preg_match("/([\w\-]+\@[\w\-]+\.[\w\-]+)/", $value)) {
					$mailCheck .= $key+1 . ' ';
				}
			}

			if (empty($params['mail_to'])) {
				$actionError = 'Введите электронный почтовый ящик, на который будут приходить сообщения.';
				$this->data['actionError'] = $actionError;
			} elseif ($mailCheck != '') {
				$actionError = 'Почтовые ящики под номерами: ' . $mailCheck . ' не корректны.';
				$this->data['actionError'] = $actionError;
			} else {
				$this->data['mail_to'] = $params['mail_to'];
			}

			$this->page['html'] = $this->load_view('settings');
			return $this->page;
		}

		// public function action_activate($plugin) 
		// {
		// 	$params = unserialize($plugin['params']);

		// 	if (isset($_POST['edit_settings'])) {
		// 		$this->page['params'] = serialize(array(
		// 			'mail_to'           => $_POST['mail_to'],
		// 		));
		// 		return $this->page;
		// 	} 

		// 	$this->data['mailText'] = $params['mail_to'];
 
		// 	$explodedMailTo = explode(', ', $params['mail_to']);
		// 	$mailCheck = '';
		// 	foreach ($explodedMailTo as $key => $value) {
		// 		if (!preg_match("/([\w\-]+\@[\w\-]+\.[\w\-]+)/", $value)) {
		// 			$mailCheck .= $key+1 . ' ';
		// 		}
		// 	}

		// 	if (empty($params['mail_to'])) {
		// 		$actionError = 'Введите электронный почтовый ящик, на который будут приходить сообщения.';
		// 		$this->data['actionError'] = $actionError;
		// 	} elseif ($mailCheck != '') {
		// 		$actionError = 'Почтовые ящики под номерами: ' . $mailCheck . ' не корректны.';
		// 		$this->data['actionError'] = $actionError;
		// 	} else {
		// 		$this->data['mail_to'] = $params['mail_to'];
		// 	}

		// 	$this->page['html'] = $this->load_view('settings');
		// 	return $this->page;
		// }

		public function action_index($plugin) 
		{
			$params = unserialize($plugin['params']);

			$this->page['title'] = 'Почта ' . SITE_NAME;
			$this->page['keywords'] = 'Почта';
			$this->page['description'] = 'Почта';

			$this->data['uri'] = $_SERVER['REQUEST_URI'];
			// print_r($_SERVER);
			// $_SERVER['HTTP_HOST']

			if (empty($params['mail_to'])) {
				$this->data['mailToError'] = 'Укажите ваш e-mail для получения почты в настройках модуля: <a href="/admin">в администрировании сайта</a> зайдите в МОДУЛИ, найдите этот модуль по названию "feedback_with_attachments", нажмите настройки->параметры и введите e-mail, на который вы хотите получать письма!';
			} else {
				$mails = $params['mail_to'];
				$explodedMails = explode(', ', $mails);
				$to = $explodedMails;
			}

			if (isset($_POST['submit'])) {

				$errors = array();

				$from = htmlspecialchars($_POST['from']);
				$this->data['from'] = $from;
				$subject = htmlspecialchars($_POST['subject']);
				$this->data['subject'] = $subject;
				$message = htmlspecialchars($_POST['message']);
				$this->data['message'] = $message;
				

				if (empty($from)) {
					$errors['from'] = 'Введите почту.';
				} elseif (!preg_match("/([\w\-]+\@[\w\-]+\.[\w\-]+)/", $from)) {
					$errors['from'] = 'Введенная почта некорректна.';
				}
				if (empty($message)) {
					$errors['message'] = 'Введите сообщение.';
				}
				$phoneCharArr = array('1', '2', '3', '4', '5' ,'6', '7', '8', '9', '0', '-', '+', ' ', '(', ')', '');
				$phoneMatch = preg_split('//', $subject);  
				$phonePushArr = array();
				foreach ($phoneMatch as $key => $value) {
					if (!in_array($value, $phoneCharArr)) {
						array_push($phonePushArr, $value);
					}
				}
				if (empty($subject)) {
					$this->data['phoneError'] = 'Введите телефон.';
					array_push($errors, $this->data['phoneError']);
				} elseif (!empty($phonePushArr)) {
					$this->data['phoneError'] = 'Введенный телефон некорректен.';
					array_push($errors, $this->data['phoneError']);
				}

				$this->data['errors'] = $errors;

				if (count($errors) == 0) {

					$headers = "From: $from";

					// boundary
					$semi_rand = md5(time());
					$mime_boundary = "==Multipart_Boundary_x{$semi_rand}x";

					// headers for attachment
					$headers .= "\nMIME-Version: 1.0\n" . "Content-Type: multipart/mixed;\n" . " boundary=\"{$mime_boundary}\"";

					// multipart boundary
					$message = "This is a multi-part message in MIME format.\n\n" . "--{$mime_boundary}\n" . "Content-Type: text/plain; charset=\"iso-8859-1\"\n" . "Content-Transfer-Encoding: 7bit\n\n" . $message . "\n\n";
					$message .= "--{$mime_boundary}\n";

					// preparing attachments
					foreach ($_FILES as $key => $value) {
						if ($value['error'] == 0) {
							$data = chunk_split(base64_encode($value['size']));
							$message .= "Content-Type: {\"application/octet-stream\"};\n";
							$message .= "name=\"" . $value['name'] . "\"\n";
							$message .= "Content-Disposition: attachment;\n" . " filename=\"" . $value['name'] . "\"\n";
							$message .= "Content-Transfer-Encoding: base64\n\n" . $data . "\n\n";
							$message .= "--{$mime_boundary}\n";
						}
					}

					// print_r($to);
					$mailSend = 'Ваше письмо было отправлено по адресу: ';
					foreach ($to as $certainMail) {
						$tryMail = mail($certainMail, $subject, $message, $headers);
						$mailSend .= $certainMail . ' ';
						// echo $certainMail;
					}

					if ($tryMail) {
						$this->data['mailSend'] = $mailSend;
						$this->data['from'] = '';
						$this->data['subject'] = '';
						$this->data['message'] = '';
					} else {
						$this->data['mailError'] = 'Произошла техническая ошибка и ваше письмо не может быть отправлено в данный момент.';
					} 
				}
			}
			$this->page['head'] = $this->add_css_file(SITE_URL . '/modules/plugins/feedback_with_attachments/views/feedback_with_attachments.css');
			$this->page['html']  = $this->load_view();
			return $this->page;
		}
	}
?>